<template>
    <div>
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': errors && errors.length,
                'text-red-500': errors && errors.length,
                'font-black': boldLabel,
            }"
        >
            {{ label || name }}
        </label>
        <div
            :id="id"
            class="relative"
            :class="{
                'mt-1': multiple
            }"
        >
            <div
                class="space-y-2"
                :class="{
                    'lg:grid lg:grid-cols-2': twoPerRowOnLg && multiple
                }"
            >
                <div
                    v-for="(opt, i) in options"
                    :key="`opt-${name || ''}-${i}`"
                    class="flex items-center space-x-1 cursor-pointer align-middle self-center"
                    @click="toggleOption(opt.value)"
                >
                    <svg
                        v-if="selectedList.includes(String(opt.value))"
                        xmlns="http://www.w3.org/2000/svg" :width="checkBoxWidth" :height="checkBoxHeight" viewBox="0 0 24 24"
                    >
                        <path d="M22 2v20h-20v-20h20zm2-2h-24v24h24v-24zm-5.541 8.409l-1.422-1.409-7.021 7.183-3.08-2.937-1.395 1.435 4.5 4.319 8.418-8.591z" />
                    </svg>
                    <svg
                        v-else
                        xmlns="http://www.w3.org/2000/svg" :width="checkBoxWidth" :height="checkBoxHeight" viewBox="0 0 24 24"
                    >
                        <path d="M22 2v20h-20v-20h20zm2-2h-24v24h24v-24z"/>
                    </svg>
                    <span>{{ opt.text }}</span>
                </div>
            </div>
        </div>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="errors && errors.length"
        >
            <div
                v-for="(err, i) in errors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {onMounted, ref, watch, computed} from 'vue';
const props = defineProps({
    id: {
        required: false,
        type: [String, Number],
        default: null,
    },
    checkBoxWidth: {
        required: false,
        type: Number,
        default: 20,
    },
    checkBoxHeight: {
        required: false,
        type: Number,
        default: 20,
    },
    twoPerRowOnLg: {
        required: false,
        type: Boolean,
        default: true
    },
    name: {
        required: true,
        type: [String, Number],
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    multiple: {
        required: false,
        type: Boolean,
        default: false,
    },
    modelValue: {
        required: false,
        type: [String, Number, Boolean, Array],
        default: '',
    },
    options: {
        required: true,
        type: Array
    },
    errors: {
        required: false,
        type: Array,
        default: () => [],
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    }
});
let data = ref(props.modelValue);
const emit = defineEmits(['update:modelValue']);

onMounted(() => {
    if (props.multiple && !Array.isArray(data.value)) {
        data.value = [];
    }
});

const selectedList = computed(() => {
    let arr = [];
    if (Array.isArray(data.value)) {
        data.value.forEach(r => {
            arr.push(String(r));
        });
    } else {
        arr.push(String(data.value));
    }

    return arr;
});

const isSelected = (value) => {
    if (Array.isArray(data.value)) {
        return data.value.includes(String(value));
    } else {
        return String(value) === String(data.value);
    }
};

const toggleOption = (value) => {
    if (Array.isArray(data.value)) {
        if (data.value.includes(String(value))) {
            data.value = data.value.filter(r => String(r) !== String(value));
        } else {
            data.value.push(String(value));
        }
    } else {
        if (String(value) === String(data.value)) {
            data.value = '';
        } else {
            data.value = String(value);
        }
    }

    emit('update:modelValue', data.value);
};
</script>
